#include "dex.h"
#include "ui_dex.h"

dex::dex(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::dex)
{
    ui->setupUi(this);
}

dex::~dex()
{
    delete ui;
}

void dex::hexNumberChanged(QString hexString)
{

    quint64 hexNumber;
    bool ok;
    QChar c;
    char i;
    quint8 len;
    quint8 k;
    quint8 pos;


    pos = ui->hexLineEdit->cursorPosition();
    c = hexString[pos-1];
    hexString = hexString.toUpper();

    len = hexString.length();

    k = 0;

    while (k < len)
        {
        c = hexString[k];
        i = c.toLatin1();
        if ((i < 48) || ((i > 57) && (i < 65)) || (i > 71))
            {
            hexString = hexString.remove(k,1);
            ui->hexLineEdit->setText(hexString);
            pos--;
            k = len + 1;
            }
        k++;
        }

    hexNumber = hexString.toInt(&ok,16);

    ui->hexLineEdit->setText(hexString);

    ui->decimaLineEdit->setText(QString::number(hexNumber,10));

    ui->hexLineEdit->setCursorPosition(pos);

}

void dex::decimalNumberChanged(QString decimalString)
{

    quint64 decimalNumber;
    QChar c;
    char i;
    quint8 len;
    quint8 k;
    quint8 pos;


    len = decimalString.length();
    pos = ui->decimaLineEdit->cursorPosition();
    k = 0;

    while (k < len)
        {
        c = decimalString[k];
        i = c.toLatin1();

        if ((i < 48) || (i > 57))
            {
            decimalString = decimalString.remove(k,1);
            ui->decimaLineEdit->setText(decimalString);
            pos--;
            k = len + 1;
            }
        k++;
        }

    decimalNumber = decimalString.toLong();

    ui->hexLineEdit->setText(QString::number(decimalNumber,16).toUpper());
    ui->decimaLineEdit->setCursorPosition(pos);

}

void dex::checkValidHexNumber(QString hex)
{

    QChar c;
    char i;


    c = hex[hex.length()-1];

    i = c.toLatin1();

    if ((i < 47) || ((i > 57) && (i < 65)) || (i > 71))
        hex.chop(1);


}
